﻿package com {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import fl.controls.Slider; 
	import fl.events.SliderEvent; 
	import fl.controls.Label; 
	import fl.containers.UILoader;  
	import flash.utils.Timer;
	import flash.net.Socket;
	import flash.utils.ByteArray;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	
	public class Arena extends MovieClip {
		public var sock:Socket = new Socket();
		public var usb_light:Number;
		public var usb_switch:Boolean;
		
		private var maxLight:Number;
		private var score:Number;
		private var doodle:Doodle;
		private var fireWait:Boolean;
		private var fireLock:Boolean;
		
		private var scoreControl:Timer;
		private var bulletControl:Timer;
		private var enemyControl:Array;
		
		public var speed:Number;
		
		private var bullets:Array;
		private var enemies:Array;
		private var items:Array;
		
		private var barrier:Barrier;
		
		private var soundChannel : SoundChannel;
		public var bang:Bang;
		public var getItem:GetItem;
		public var _highScore:HighScore;
		public var _shoot:Shoot;
		
		
		public var _enemy3:SEnemy3;
		
		public var _BGM1:BGM1;
		public var _BGM2:BGM2;
		

		public function Arena() {
			// constructor code
			soundChannel = new SoundChannel();
			bang = new Bang();
			getItem = new GetItem();
			_highScore = new HighScore();
			_shoot = new Shoot();
			_enemy3 = new SEnemy3();
			_BGM1 = new BGM1();
			_BGM2 = new BGM2();
			
			fireLock = false;
			enemyControl = [];
			
			barrier = new Barrier();
			
			sock.addEventListener(Event.CONNECT,connect);
			sock.addEventListener(ProgressEvent.SOCKET_DATA,receivePacket);
			sock.connect("127.0.0.1",50007);
		}
		
		function receivePacket(event:ProgressEvent):void
		{
			if (! sock.connected)
			{
				return;
			}
			if (sock.bytesAvailable > 0)
			{
				var bytes:ByteArray = new ByteArray();
				sock.readBytes(bytes);
				var recvStr:String = bytes.toString().split("-")[0];
				usb_light = Number(recvStr.split(":")[0]);
				usb_switch = Boolean(int(recvStr.split(":")[1]));
			}
		}
		
		function connect(event:Event):void
		{
			sock.writeUTF("GET / HTTP/1.0");
			trace("Connect",sock.connected.toString());
		}

		public function startGame() {
			// init score
			score = 0;
			speed = 4;
			
			// create doodle
			doodle = new Doodle();
			addChild(doodle);
			
			bullets = new Array();
			enemies = new Array();
			items = new Array();
			
			fireWait = false;
			fireLock = false;

			stage.addEventListener(Event.ENTER_FRAME,keyDownFunction);
			stage.addEventListener(Event.ENTER_FRAME,keyUpFunction);
			
			addEventListener(Event.ENTER_FRAME, eventChange);
			
			scoreControl = new Timer(10);
			scoreControl.addEventListener(TimerEvent.TIMER,scorePlus);
			scoreControl.start();
			
			barrier.visible = false;
			addChild(barrier);
			
			setBullet();
			setEnemy();
						
		}
		
		public function removeEnemyControl(ev:int) {
			enemyControl[ev].removeEventListener(TimerEvent.TIMER,this["newEnemy_"+ ev]);
		}
		
		private function setEnemy():void { 
			enemyControl[0] = new Timer(Math.random()*2000);
			enemyControl[0].addEventListener(TimerEvent.TIMER,newEnemy_0);
			enemyControl[0].start();
			
			enemyControl[1] = new Timer(10000);
			enemyControl[1].addEventListener(TimerEvent.TIMER,newEnemy_1);
			enemyControl[1].start();
			
			enemyControl[2] = new Timer(20000);
			enemyControl[2].addEventListener(TimerEvent.TIMER,newEnemy_2);
			enemyControl[2].start();
			
			enemyControl[3] = new Timer(21000);
			enemyControl[3].addEventListener(TimerEvent.TIMER,newEnemy_3);
			enemyControl[3].start();
			
			enemyControl[4] = new Timer(25000);
			enemyControl[4].addEventListener(TimerEvent.TIMER,newEnemy_4);
			enemyControl[4].start();
			
			enemyControl[5] = new Timer(40000);
			enemyControl[5].addEventListener(TimerEvent.TIMER,newEnemy_5);
			enemyControl[5].start();
			
			enemyControl[6] = new Timer(50000);
			enemyControl[6].addEventListener(TimerEvent.TIMER,newEnemy_6);
			enemyControl[6].start();
			
			enemyControl[7] = new Timer(60000);
			enemyControl[7].addEventListener(TimerEvent.TIMER,newEnemy_7);
			enemyControl[7].start();
			
			enemyControl[8] = new Timer(60000);
			enemyControl[8].addEventListener(TimerEvent.TIMER,newEnemy_8);
			enemyControl[8].start();
			
			enemyControl[9] = new Timer(80000);
			enemyControl[9].addEventListener(TimerEvent.TIMER,newEnemy_9);
			enemyControl[9].start();
			
			enemyControl[10] = new Timer(100000);
			enemyControl[10].addEventListener(TimerEvent.TIMER,newEnemy_10);
			enemyControl[10].start();
			
			
			// BARRIER!!!
			enemyControl[11] = new Timer(15000);
			enemyControl[11].addEventListener(TimerEvent.TIMER,newEnemy_11);
			enemyControl[11].start();
			
		}
		
		public function newEnemy_0(event:TimerEvent) {
			var en:Enemy_0 = new Enemy_0(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[0].delay = 1000 + Math.random()*1000;
		}
		public function newEnemy_1(event:TimerEvent) {
			var en:Enemy_4 = new Enemy_4(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[1].delay = 1000 + Math.random()*4000;
		}
		
		public function newEnemy_2(event:TimerEvent) {
			var en:Enemy_1 = new Enemy_1(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[2].delay = 1000 + Math.random()*2000;
		}
		public function newEnemy_3(event:TimerEvent) {
			var en:Enemy_0 = new Enemy_0(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[3].delay = 1000 + Math.random()*1000;
		}
		public function newEnemy_4(event:TimerEvent) {
			removeEnemyControl(0);
			var en:Enemy_6 = new Enemy_6(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[4].delay = 2000 + Math.random()*2000;
		}
		public function newEnemy_5(event:TimerEvent) {
			removeEnemyControl(1);
			var en:Enemy_2 = new Enemy_2(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[5].delay = 2000 + Math.random()*2000;
		}
		public function newEnemy_6(event:TimerEvent) {
			removeEnemyControl(3);
			removeEnemyControl(4);
			
			var en:Enemy_5 = new Enemy_5(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[6].delay = 3000 + Math.random()*5000;
		}
		public function newEnemy_7(event:TimerEvent) {
			var en:Enemy_0 = new Enemy_0(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[7].delay = 1000 + Math.random()*2000;
		}
		public function newEnemy_8(event:TimerEvent) {
			var en:Enemy_4 = new Enemy_4(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[8].delay = 1000 + Math.random()*3000;
		}
		public function newEnemy_9(event:TimerEvent) {
			var en:Enemy_3 = new Enemy_3(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[9].delay = 2000 + Math.random()*2000;
		}
		public function newEnemy_10(event:TimerEvent) {
			var en:Enemy_6 = new Enemy_6(1100, rand(0, 540));
			addEnemy(en, true);
			enemyControl[10].delay = 3000 + Math.random()*2000;
		}
		public function newEnemy_11(event:TimerEvent) {
			var en:Item_0 = new Item_0(1100, rand(0, 540));
			addItem(en);
			enemyControl[11].delay = 15000 + Math.random()*10000;
		}
		
		
		private function addEnemy(en:Enemy , col:Boolean)
		{
			en.visible = false;
			if(en is Enemy_0) rockLayer.addChild(en);
			else enemyLayer.addChild(en);
			
			if(col)
				for (var enemyNum:int=enemies.length-1;enemyNum>=0;enemyNum--) {
					if(HitTesting.complexHitTestObject(en, enemies[enemyNum], 1)){
						if(en is Enemy_2) Enemy_2(en).removeShoot();
						if(en is Enemy_3) {enemies[enemyNum].gotoAndStop(1); Enemy_3(en).removeBomb();}
						
						en.remove();
						return;
					}
				}
			enemies.push(en);
			en.visible = true;
		}
		
		private function addHole(en:Enemy_8)
		{
			holeLayer.addChild(en);
			enemies.push(en);
		}
		
		private function addItem(it:Item)
		{
			itemLayer.addChild(it);
			items.push(it);
		}
		
		private function setBullet():void { 
			bulletControl = new Timer(Bullet.delay,1);
			bulletControl.addEventListener(TimerEvent.TIMER_COMPLETE,canFire);
			bulletControl.start();
		}
		
		private function canFire(event:TimerEvent)
		{
			fireWait = false;
		}
		
		private function setBarrier(ck:Boolean)
		{
			doodle.barrier = ck;
			barrier.x = doodle.x;
			barrier.y = doodle.y;
			barrier.visible = ck;
		}
		
		private function eventChange(event:Event):void { 
			if(usb_light > maxLight) usb_light = maxLight;
			doodle.des_vel = usb_light/maxLight * 20 - 10;
			var enemyNum:int;
			var itemNum:int;
			
			if(doodle.barrier)
			{
				barrier.x = doodle.x;
				barrier.y = doodle.y;
			}
			
			for(var bulletNum:int=bullets.length-1;bulletNum>=0;bulletNum--){ 
				for (enemyNum=enemies.length-1;enemyNum>=0;enemyNum--) {
					if(enemies[enemyNum] is Enemy_8) continue;
					if(HitTesting.complexHitTestObject(bullets[bulletNum], enemies[enemyNum], 1)){
						bang.play();
						enemies[enemyNum].animate();
						bullets[bulletNum].remove();
						removeEnemy(enemies[enemyNum]);
						break;
					}
				}
			}
			
			for (itemNum=items.length-1;itemNum>=0;itemNum--) {
				if(HitTesting.complexHitTestObject(doodle, items[itemNum], 1)){
					getItem.play();
					items[itemNum].animate();
					if(items[itemNum] is Item_0)  setBarrier(true);
					
					break;
				}
			}
			
			for (enemyNum=enemies.length-1;enemyNum>=0;enemyNum--) {
				if(HitTesting.complexHitTestObject(doodle, enemies[enemyNum], 1)){
					bang.play();
					if(doodle.barrier && !(enemies[enemyNum] is Enemy_8))
					{
						enemies[enemyNum].animate();
						removeEnemy(enemies[enemyNum]);
						setBarrier(false);
					    break;
					}
					else if(doodle.barrier) setBarrier(false);
					clean();
					doodle.stopFire();
					doodle.stopMove();
					doodle.play();
					speed = 0;
					
					resultBoard.resultBoard.resultScoreTxt.text = "Your score is " + score.toString();
					if(highScore.data.score < score)
					{
						_highScore.play();
						resultBoard.resultBoard.resultHighScoreTxt.text = "NEW HIGHSCORE";
						highScore.data.score = score;
						highScore.flush();
					}
					else
						resultBoard.resultBoard.resultHighScoreTxt.text = "High score is " + highScore.data.score.toString();
					
					stage.addEventListener(Event.ENTER_FRAME,keyDownEnd);
					stage.addEventListener(Event.ENTER_FRAME,keyUpEnd);
					
					resultBoard.play();
					break;
				}
			}
		}
		
		public function clean()
		{
			var i:int;
			
			for(i =  enemyControl.length-1; i >= 0; i--) 
			{
				enemyControl[i].removeEventListener(TimerEvent.TIMER,this["newEnemy_"+i]);
			}
			
			scoreControl.removeEventListener(TimerEvent.TIMER,scorePlus);
			bulletControl.removeEventListener(TimerEvent.TIMER_COMPLETE,canFire);
			removeEventListener(Event.ENTER_FRAME, eventChange);
			stage.removeEventListener(Event.ENTER_FRAME,keyDownFunction);
			stage.removeEventListener(Event.ENTER_FRAME,keyUpFunction);
		}
		
		public function reset()
		{
			var enemyNum:int;
			var bulletNum:int;
			var itemNum:int;
			
			for (bulletNum=bullets.length-1;bulletNum>=0;bulletNum--){ 
				bullets[bulletNum].remove();
			}
			for (itemNum=items.length-1;itemNum>=0;itemNum--) {
				items[itemNum].remove();
			}
			for (enemyNum=enemies.length-1;enemyNum>=0;enemyNum--) {
				if(enemies[enemyNum] is Enemy_2) Enemy_2(enemies[enemyNum]).removeShoot();
				if(enemies[enemyNum] is Enemy_3) {enemies[enemyNum].gotoAndStop(1); Enemy_3(enemies[enemyNum]).removeBomb();}
				enemies[enemyNum].remove();
			}
			
			while(enemies.length > 0)
				enemies.pop();
			while(bullets.length > 0)
				bullets.pop();
			removeEventListener(Event.ENTER_FRAME, moveGrid);
			gotoAndStop(1);
		}
		
		private function keyDownEnd(event:Event) {
			if (!fireLock && canGoMenu && usb_switch) {
				stage.removeEventListener(Event.ENTER_FRAME,keyDownEnd);
				stage.removeEventListener(Event.ENTER_FRAME,keyUpEnd);
				reset();
			}
			fireLock = true;
		}
		private function keyUpEnd(event:Event) {
			//trace(usb_switch);
			if (!usb_switch) {
				fireLock = false;
			}
		}
		
		private function keyDownFunction(event:Event) {
			if (!fireWait && !fireLock && usb_switch) {
				fireWait = true;
				fireBullet();
				setBullet();
			}
			fireLock = true;
		}
		private function keyUpFunction(event:Event) {
			if (!usb_switch) {
				fireLock = false;
			}
		}
		
		
		private function fireBullet()
		{
			_shoot.play();
			var b:Bullet = new Bullet(doodle.x+34,doodle.y-6);
			bulletLayer.addChild(b);
			bullets.push(b);
		}
		
		// take a bullet from the array
		public function removeBullet(bullet:Bullet) {
			for(var i in bullets) {
				if (bullets[i] == bullet) {
					bullets.splice(i,1);
					break;
				}
			}
		}
		
		public function removeEnemy(en:Enemy) {
			for(var i in enemies) {
				if (enemies[i] == en) {
					enemies.splice(i,1);
					break;
				}
			}
		}
		
		public function removeItem(it:Item) {
			for(var i in items) {
				if (items[i] == it) {
					items.splice(i,1);
					break;
				}
			}
		}
		
		public function bomb(en:Enemy_3)
		{
			_enemy3.play();
			var hole:Enemy_8 = new Enemy_8(en.x, en.y);
			en.remove();
			addHole(hole);
		}
		
	
		public function shoot(en:Enemy_2)
		{
			var nx = en.x-22.05;
			var ny = en.y-13.45;
			var slope = Math.atan((ny-doodle.y)/(nx-doodle.x));
			var bul:Enemy_9 = new Enemy_9(nx, ny, en.scaleX, en.scaleY, slope);
			addEnemy(bul, false);
		}
		
		public function getDoodleX()
		{
			return doodle.x;
		}
		
		public function rand(min:Number, max:Number ):Number
		{
			 return min + (max - min) * Math.random();
		}
		
		public function scorePlus(e:TimerEvent) {
			score += speed / 4;
			scoreTxt.text = String("Score: " + score);
			
			if(highScore.data.score < score)
			{
				highScoreTxt.text = "High Score " + score.toString();
			}
		}
		
	}
	
}
